package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.Container;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * HTML generation for Container widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class ContainerHTML_Bak extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Container tag = (Container) genericTag;

        out.print( "<div " );
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");        
        out.print(getSpecificStyleAttr(tag) + " "); //out.print(getStyleAttr(tag) + " ");
        out.print(getTitleAttr(tag) + " ");
        out.println(" >");        
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Container tag = (Container) genericTag;
        
        out.println( "</div>");
        
        //--- Generate the script to set the specific "onpopulate" event
        if  ( tag.getOnpopulate() != null )
        {            
			out.println("<script type=\"text/javascript\" >");
			out.println("var telosysTempVar = document.getElementById(\"" + tag.getId() + "\" );" );
			out.println("if ( telosysTempVar != null ) {");
			out.println(" telosysTempVar.onpopulate =\"" + tag.getOnpopulate() + "\" ; " );
			out.println("} else {");
			out.println(" alert ( \"ERROR : Cannot found container '" + tag.getId() + "' \" );" );
			out.println("}");
			out.println("</script>");
        }
        
        //--- Register the current view container via Javascript ...
        registerView(tag);
    }
    //----------------------------------------------------------------
    //----------------------------------------------------------------
    private String getSpecificStyleAttr(Container tag)
    {        
        if (tag.isPositionAbsolute())
        {
            return getStyleAttrWithPosition(tag);
        }
        else
        {
            //--- Style set by user + Width/Height + force "relative position"
            String sStyle = getStyleFragUserStyle(tag) + getStyleFragWidthHeight(tag) + "position:relative;" ;
            return " style=\"" + sStyle + "\" " ;            
        }
    }
    //----------------------------------------------------------------
    private void registerView(Container tag) 
    {
        if ( tag.hasId() && ( tag.hasZone() || ( tag.getData() != null ) ) )
        {
            String sJavascript = "RegisterView(" + buildArgumentsList(tag) + ")";
            tag.addJavascriptLine(sJavascript);
        }
    }    
    //----------------------------------------------------------------
    private String buildArgumentsList(GenericTag tag)
    {
        //--- 1 : Tag ID
        String sId = "\"" + tag.getId() + "\"";

        //--- 2 : Zone name
        String sZone = "null";
        if (tag.hasZone())
        {
            sZone = tag.getZone();
            if (sZone != null)
            {
                sZone = "\"" + sZone.trim() + "\"";
            }
        }

        //--- 3 : Data name 
        String sData = tag.getData();
        if ( sData != null )
        {
            sData = "\"" + sData.trim() + "\"";
        }
        else
        {
            sData = "null";
        }
        
        return sId + ", " + sZone + ", " + sData ;
    }    
}